hdu 5441 Travel(带权并查集)

39 篇文章 0 订阅
2 篇文章 0 订阅
Problem Description
Jack likes to travel around the world, but he doesn’t like to wait. Now, he is traveling in the Undirected Kingdom. There are  n  cities and  m  bidirectional roads connecting the cities. Jack hates waiting too long on the bus, but he can rest at every city. Jack can only stand staying on the bus for a limited time and will go berserk after that. Assuming you know the time it takes to go from one city to another and that the time Jack can stand staying on a bus is  x  minutes, how many pairs of city  (a,b)  are there that Jack can travel from city  a  to  b  without going berserk?
 

Input
The first line contains one integer  T,T5 , which represents the number of test case.

For each test case, the first line consists of three integers  n,m  and  q  where  n20000,m100000,q5000 . The Undirected Kingdom has  n  cities and  m bidirectional roads, and there are  q  queries.

Each of the following  m  lines consists of three integers  a,b  and  d  where  a,b{1,...,n}  and  d100000 . It takes Jack  d  minutes to travel from city  a  to city  b and vice versa.

Then  q  lines follow. Each of them is a query consisting of an integer  x  where  x  is the time limit before Jack goes berserk.

 

Output
You should print  q  lines for each test case. Each of them contains one integer as the number of pair of cities  (a,b)  which Jack may travel from  a  to  b  within the time limit  x .

Note that  (a,b)  and  (b,a)  are counted as different pairs and  a  and  b  must be different cities.
 

Sample Input
  
  
1 5 5 3 2 3 6334 1 5 15724 3 5 5705 4 3 12382 1 3 21726 6000 10000 13000
 

Sample Output
  
  
2 6 12

solution:

有一个n个点的无向图,给出m条边的边权,给出q次询问,每次给出一个值,求用到所有边权不大于这个值的边的情况下,能够互相到达的点对的个数。刚开始以为是最短路变形,但后来发现可以用带权并查集做,把查询读入后从小到大排序,然后对于每次查询,我用并查集维护边权不大于这个值的每个联通块中节点个数,若可以合并u,v,且num[i]代表以i为根的联通块的节点数,则要加上(num[u] + num[v])*(num[u] + num[v] - 1) - num[u] * (num[u] - 1) - num[v] * (num[v] - 1),因为在次之前我们已经累加过num[i] * (num[i] - 1)。在每次合并时,我们应该选准压缩路径的方向,我每次都是把节点编号大的插在节点编号小的下面。

详细看代码~

#include<cstdio>
#include<algorithm>
using namespace std;
const int maxn = 20500;
int fa[maxn], num[maxn],ans[maxn];
int n;
struct edge{
    int u, v, w;
    bool operator <(const edge &x)const
    {
        return w < x.w;
    }
}e[maxn*5];
struct Query
{
    int id, x;
    bool operator <(const Query &a)const
    {
        return x < a.x;
    }
}query[maxn];
void init()
{
    for (int i = 1; i <= n; i++)
    {
        num[i] = 1; 
        fa[i] = i;
    }
}
int find(int x)
{
    if (fa[x] == x)return x;
    return fa[x] = find(fa[x]);
}
void _union(int x, int y)
{
    x = find(x); y = find(y);
    if (x > y)swap(x, y);
    fa[y] = x;
    num[x] += num[y];
}
int main()
{
    int t,m,q;
    scanf("%d", &t);
    while (t--)
    {
        scanf("%d%d%d", &n, &m, &q);
        init();
        for (int i = 0; i <m; i++)
            scanf("%d%d%d", &e[i].u, &e[i].v, &e[i].w);
        sort(e, e + m);
        for (int i = 0; i < q; i++)
        {
            query[i].id = i;
            scanf("%d", &query[i].x);
        }
        sort(query, query + q);
        int j = 0, tmp = 0;
        for (int i = 0; i < q; i++)
        {
            while (j < m&&e[j].w <= query[i].x)
            {
                int u = find(e[j].u), v = find(e[j].v);
                j++;
                if (u == v)continue;
                tmp += (num[u] + num[v])*(num[u] + num[v] - 1) - num[u] * (num[u] - 1) - num[v] * (num[v] - 1);
                _union(u, v);
            }
            ans[query[i].id] = tmp;
        }
        for (int i = 0; i < q; i++)
            printf("%d\n", ans[i]);
    }
    return 0;
}


  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 1
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值